
#Mesurem el temps que triga en executarse l'anàlisi d'una hora
start_time_set_stations <- Sys.time()

# 
pollutant <- "no2"

# 
# # !!! OJO !!! Aqui t'agafa les estacions del mes de l'any de date_time_begin, potser no hi son totes!!
# # Lo ideal  seria que et mires cada mes des de date_time_begin fins a date_time_end i agafes el vector més llarg
obs_path_stations      <- paste0(obs_path, "sconc",pollutant,"_",year_month[1],".nc")



#Dades de les estacions:
netcdf_obs        <- RNetCDF::open.nc(obs_path_stations)

#Arreglem les dades de les observacions
lat_obs      <- RNetCDF::var.get.nc(netcdf_obs, 'latitude') 
lon_obs      <- RNetCDF::var.get.nc(netcdf_obs, 'longitude')
ref_obs      <- RNetCDF::var.get.nc(netcdf_obs, 'station_reference')
station_name <- RNetCDF::var.get.nc(netcdf_obs, "station_name")
obs_all      <- RNetCDF::var.get.nc(netcdf_obs, "sconcno2")
df_obs       <- data.frame(NO2=obs_all[1,], lat_obs=lat_obs, lon_obs=lon_obs, ref_obs=ref_obs,station_name=station_name)
coordinates(df_obs)=~lon_obs+lat_obs



#Coordenades

sp::proj4string(df_obs)   <- crs_model




#Assignar el limit 'box' en el mapa
my_box      <- rgeos::bbox2SP(43.02355,40.24870,3.497162,-0.001190186, proj4string = CRS(crs_model)) # lat màx, lat min, lon max, lon min

#Extraiem les coordenades de les observacions que es troben dintre de l'àrea limitada 'my box'
conjunt     <- raster::intersect(df_obs,my_box) #Fa una llista de les obs de NO2 que estiguin dindre de l'àrea del box

local_stations <- sp::spTransform(conjunt, sp::CRS(crs_model_utm))


saveRDS(object=local_stations, file=paste0(sim_folder_path,"local_stations.rds"))
#saveRDS save data into R Data Format

rm(obs_path_stations,netcdf_obs,lat_obs,lon_obs,ref_obs,station_name,obs_all,df_obs,my_box,conjunt)

end_time_set_stations <- Sys.time()
temps_total <- end_time_set_stations - start_time_set_stations
print(paste0(temps_total," local stations"))